#include <stdio.h>
#include <stdlib.h>
#include <math.h>
double **vyroba2Dpole(int r, int s)
{
    double **pX;
    int i;
    pX=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
    {
        *(pX+i)=(double *)malloc(s*sizeof(double));
        /* pX[i]=(double *)malloc(s*sizeof(double)); */
    }
    return(pX);
}
void uvolni(double **pX, int r)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)pX[i]);
    free((void *)pX);
}
void soubor(double **pX, int k, int r, int s)
{
    FILE *fw;
    int i,j,q;
    char nazev[30], vystup[34], radka[50];
    printf("Zadej jmeno souboru bez pripony: ");
    scanf("%29s",nazev);
    sprintf(vystup,"%s.csv",nazev);
    printf("\nBude se ukladat do %s\n",vystup);
    if((fw=fopen(vystup,"w"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    q=0;
    for(i=0; i<=360; i+=k)      /*i+=k je i=i+k*/
    {
        pX[q][0]=(double)i;
        pX[q][1]=sin(pX[q][0]*M_PI/180); /*sin - prevod na radiany*/
        if(i==0)
            sprintf(radka,"%5.0f;%10.4f;%10c;\n",pX[q][0],pX[q][1],'-');
        else
        {
            pX[q][2]=log(pX[q][0]);
            sprintf(radka,"%5.0f;%10.4f;%10.4f;\n",pX[q][0],pX[q][1],pX[q][2]);
        }
        printf("%s",radka);
        j=0;
        while(radka[j]!='\0')
        {
            if(radka[j]=='.')
                radka[j]=',';
            j++;
        }
        fprintf(fw,"%s",radka);
        q++;
    }
    if((fclose(fw))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
    FILE *fr;
    char c;
    if((fr=fopen(vystup,"r"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    if((fw=fopen("kopie.txt","w"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    while((c=getc(fr))!=EOF)
    {
        putchar(c);
        putc(c,fw);
    }
    if((fclose(fr))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
    if((fclose(fw))==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
}
int main()
{
    double **pA;
    int r,s,k;
    printf("Zadej krok od 2 do 100:\n");
    scanf("%d",&k);
    r=360/k+1;
    s=3;
    pA=vyroba2Dpole(r,s);
    soubor(pA,k,r,s);
    uvolni(pA,r);
    return 0;
}
